Exec { timeout => 300 }


class {"keystone":
    admin_token => "b9d1a93884c847988240914b0050b36c",
    sql_connection => "mysql://keystone_admin:3d12569a00c24704@192.168.2.22/keystone",
    token_format => "PKI",
    verbose => true,
    debug => false,
}

class {"keystone::roles::admin":
    email => "test@test.com",
    password => "redhat",
    admin_tenant => "admin"
}

class {"keystone::endpoint":
    public_address  => "192.168.2.22",
    admin_address  => "192.168.2.22",
    internal_address  => "192.168.2.22",
}

# Run token flush every minute (without output so we won't spam admins)
cron { 'token-flush':
    ensure => 'present',
    command => '/usr/bin/keystone-manage token_flush >/dev/null 2>&1',
    minute => '*/1',
    user => 'keystone',
    require => [User['keystone'], Group['keystone']],
} -> service { 'crond':
    ensure => 'running',
    enable => true,
}
# Create firewall rules to allow only the FIREWALL_ALLOWED
# hosts that need to connect via FIREWALL_PORTS
# using FIREWALL_CHAIN

packstack::firewall {'keystone':
  host => 'ALL',
  service_name => 'keystone',
  chain => 'INPUT',
  ports => ['5000', '35357'],
  proto => 'tcp',
}


class {"glance::keystone::auth":
    password => "c7d77a0be8434813",
    public_address => "192.168.2.22",
    admin_address => "192.168.2.22",
    internal_address => "192.168.2.22",
}


class {"cinder::keystone::auth":
    password => "a7f65b6658194af4",
    public_address => "192.168.2.22",
    admin_address => "192.168.2.22",
    internal_address => "192.168.2.22",
}

keystone_service { "${cinder::keystone::auth::auth_name}_v2":
    ensure      => present,
    type        => "${cinder::keystone::auth::service_type}v2",
    description => "Cinder Service v2",
}

keystone_endpoint { "${cinder::keystone::auth::region}/${cinder::keystone::auth::auth_name}_v2":
    ensure       => present,
    public_url   => "${cinder::keystone::auth::public_protocol}://${cinder::keystone::auth::public_address}:${cinder::keystone::auth::port}/v2/%(tenant_id)s",
    admin_url    => "http://${cinder::keystone::auth::admin_address}:${cinder::keystone::auth::port}/v2/%(tenant_id)s",
    internal_url => "http://${cinder::keystone::auth::internal_address}:${cinder::keystone::auth::port}/v2/%(tenant_id)s",
}


class {"nova::keystone::auth":
    password    => "c6f3968f87364945",
    public_address => "192.168.2.22",
    admin_address => "192.168.2.22",
    internal_address => "192.168.2.22",
    cinder => true,
}


class {"neutron::keystone::auth":
    password    => "14ed95f71d244bfb",
    public_address => "192.168.2.22",
    admin_address => "192.168.2.22",
    internal_address => "192.168.2.22",
}

class { 'swift::keystone::auth':
  public_address  => '192.168.2.22',
  password => '7f9a2248effb48b8',
}
