Exec { timeout => 300 }


# on EL6 we need to wait for innodb changes before starting mysqld
if $::operatingsystem in ['RedHat','CentOS','Scientific'] and $::operatingsystemmajrelease < 7 {
    $manage_service = false
    service { 'mysqld':
      enable  => true,
      ensure  => 'running',
      require => [ Package['mysql-server'], File['/etc/my.cnf'] ],
      before  => Exec['set_mysql_rootpw'],
    }
} else {
    $manage_service = true
}

class {"mysql::server":
    package_name => "mariadb-galera-server",
    manage_service => $manage_service,
    config_hash => {bind_address => "0.0.0.0",
                    default_engine => "InnoDB",
                    root_password => "1554e1239f424031",}
}

include packstack::innodb

# deleting database users for security
# this is done in mysql::server::account_security but has problems
# when there is no fqdn, so we're defining a slightly different one here
database_user { [ 'root@127.0.0.1', 'root@::1', '@localhost', '@%' ]:
    ensure  => 'absent', require => Class['mysql::config'],
}
if ($::fqdn != "" and $::fqdn != "localhost") {
    database_user { [ "root@${::fqdn}", "@${::fqdn}"]:
        ensure  => 'absent', require => Class['mysql::config'],
    }
}
if ($::fqdn != $::hostname and $::hostname != "localhost") {
    database_user { ["root@${::hostname}", "@${::hostname}"]:
        ensure  => 'absent', require => Class['mysql::config'],
    }
}

class {"keystone::db::mysql":
    user          => 'keystone_admin',
    password      => "3d12569a00c24704",
    allowed_hosts => "%",
    charset       => "utf8",
}

class {"nova::db::mysql":
    password      => "0cf820e9b2204154",
    allowed_hosts => "%",
    charset       => "utf8",
}

class {"cinder::db::mysql":
    password      => "d994d8758045491e",
    allowed_hosts => "%",
    charset       => "utf8",
}

class {"glance::db::mysql":
    password      => "ff14ff0660d64255",
    allowed_hosts => "%",
    charset       => "utf8",
}

class {"neutron::db::mysql":
    password      => "e77a85880f764856",
    allowed_hosts => "%",
    dbname        => 'neutron',
    charset       => "utf8",
}

# Create firewall rules to allow only the FIREWALL_ALLOWED
# hosts that need to connect via FIREWALL_PORTS
# using FIREWALL_CHAIN

packstack::firewall {'mysql_192.168.2.22':
  host => '192.168.2.22',
  service_name => 'mysql',
  chain => 'INPUT',
  ports => '3306',
  proto => 'tcp',
}
