Exec { timeout => 300 }

$neutron_db_host = '192.168.2.22'
$neutron_db_name = 'neutron'
$neutron_db_user = 'neutron'
$neutron_db_password = 'e77a85880f764856'
$neutron_sql_connection = "mysql://${neutron_db_user}:${neutron_db_password}@${neutron_db_host}/${neutron_db_name}"

$neutron_user_password = '14ed95f71d244bfb'



class { 'neutron':
  rabbit_host           => '192.168.2.22',
  rabbit_port           => '5672',
  rabbit_user           => 'guest',
  rabbit_password       => 'guest',
  core_plugin           => 'neutron.plugins.ml2.plugin.Ml2Plugin',
  allow_overlapping_ips => true,
  service_plugins       => ['neutron.services.l3_router.l3_router_plugin.L3RouterPlugin', 'neutron.services.firewall.fwaas_plugin.FirewallPlugin'],
  verbose               => true,
  debug                 => false,
}

class { 'neutron::server':
  sql_connection => $neutron_sql_connection,
  connection => $neutron_sql_connection,
  auth_password => $neutron_user_password,
  auth_host => '192.168.2.22',
  enabled => true,
}

exec { 'neutron-db-manage upgrade':
  command     => 'neutron-db-manage --config-file /etc/neutron/neutron.conf --config-file /etc/neutron/plugin.ini upgrade head',
  path        => '/usr/bin',
  user        => 'neutron',
  logoutput   => 'on_failure',
  before      => Service['neutron-server'],
  require     => [Neutron_config['database/connection'], Neutron_config['DEFAULT/core_plugin']],
}
# Configure nova notifications system
class { 'neutron::server::notifications':
    nova_admin_username    => 'nova',
    nova_admin_password    => 'c6f3968f87364945',
    nova_admin_tenant_name => 'services',
    nova_url               => 'http://192.168.2.22:8774/v2',
    nova_admin_auth_url    => 'http://192.168.2.22:35357/v2.0',
}

class { 'neutron::plugins::ml2':
  type_drivers          => ['vxlan'],
  tenant_network_types  => ['vxlan'],
  mechanism_drivers     => ['openvswitch'],
  flat_networks         => ['*'],
  network_vlan_ranges   => [],
  tunnel_id_ranges      => [],
  vxlan_group           => undef,
  vni_ranges            => ['10:100'],
  enable_security_group => true,
}

# For cases where "neutron-db-manage upgrade" command is called we need to fill config file first
if defined(Exec['neutron-db-manage upgrade']) {
  Neutron_plugin_ml2<||> -> File['/etc/neutron/plugin.ini'] -> Exec['neutron-db-manage upgrade']
}
# Create firewall rules to allow only the FIREWALL_ALLOWED
# hosts that need to connect via FIREWALL_PORTS
# using FIREWALL_CHAIN

packstack::firewall {'neutron_server_192.168.2.22_192.168.2.22':
  host => '192.168.2.22',
  service_name => 'neutron server',
  chain => 'INPUT',
  ports => '9696',
  proto => 'tcp',
}

# Create firewall rules to allow only the FIREWALL_ALLOWED
# hosts that need to connect via FIREWALL_PORTS
# using FIREWALL_CHAIN

packstack::firewall {'neutron_tunnel':
  host => 'ALL',
  service_name => 'neutron tunnel port',
  chain => 'INPUT',
  ports => '4789',
  proto => 'udp',
}

class { 'neutron::agents::l3':
  interface_driver        => 'neutron.agent.linux.interface.OVSInterfaceDriver',
  external_network_bridge => 'br-ex',
  debug                   => false,
}

sysctl::value { 'net.ipv4.ip_forward':
  value => '1'
}


if 'ml2' == 'ml2' {
  $agent_service = 'neutron-ovs-agent-service'
} else {
  $agent_service = 'neutron-plugin-ovs-service'
}

vs_bridge { 'br-ex':
  ensure  => present,
  require => Service["${agent_service}"]
}



if "" {
  $iface = regsubst('', '[\.\-\:]', '_', 'G')
  $localip = inline_template("<%= scope.lookupvar('::ipaddress_${iface}') %>")
} else {
  $localip = '192.168.2.22'
}

if 'ml2' == 'ml2' {
  if ('l2population' in ['openvswitch']) {
    $l2population = true
  } else {
    $l2population = false
  }
  class { 'neutron::agents::ml2::ovs':
    bridge_mappings  => [],
    enable_tunneling => true,
    tunnel_types     => ['vxlan'],
    local_ip         => $localip,
    vxlan_udp_port   => 4789,
    l2_population    => $l2population,
  }
} else {
  class { 'neutron::agents::ovs':
    bridge_mappings  => [],
    enable_tunneling => true,
    tunnel_types     => ['vxlan'],
    local_ip         => $localip,
    vxlan_udp_port   => 4789,
  }

  file { 'ovs_neutron_plugin.ini':
    path    => '/etc/neutron/plugins/openvswitch/ovs_neutron_plugin.ini',
    owner   => 'root',
    group   => 'neutron',
    before  => Service['ovs-cleanup-service'],
    require => Package['neutron-plugin-ovs'],
  }
}



class { 'packstack::neutron::bridge': }


class { 'neutron::agents::dhcp':
  interface_driver => 'neutron.agent.linux.interface.OVSInterfaceDriver',
  debug            => false,
}
# Create firewall rules to allow only the FIREWALL_ALLOWED
# hosts that need to connect via FIREWALL_PORTS
# using FIREWALL_CHAIN

packstack::firewall {'neutron_dhcp_in_192.168.2.22':
  host => 'ALL',
  service_name => 'neutron dhcp in: ',
  chain => 'INPUT',
  ports => '67',
  proto => 'udp',
}
# Create firewall rules to allow only the FIREWALL_ALLOWED
# hosts that need to connect via FIREWALL_PORTS
# using FIREWALL_CHAIN

packstack::firewall {'neutron_dhcp_out_192.168.2.22':
  host => 'ALL',
  service_name => 'neutron dhcp out: ',
  chain => 'OUTPUT',
  ports => '68',
  proto => 'udp',
}

class {'neutron::agents::metadata':
  auth_password => '14ed95f71d244bfb',
  auth_url      => 'http://192.168.2.22:35357/v2.0',
  shared_secret => '765c03a833a04c39',
  metadata_ip   => '192.168.2.22',
  debug         => false,
}

